<?php
/***
	© 2012 Martyn Armitage - servicepointsoftware.co.uk
	This code is supplied without warranty and on the basis that 
	no responsibility is accepted for any issues that may arise from its use,
	either as it stands or with end user modifications.
	Installing and using the code will indicate your acceptance of the above
	thereby absolving the author of any responsibility.
	The copyright and condition of use must remain intact with the code.
***/
function hikashop_characteristics_html(&$element,&$params,&$obj)
{
	switch($params->get('characteristic_display'))
	{
		case 'table':
			$html='';
		break;

		default:
		case 'radio':
		case 'dropdown':
			$main_html = '<table class="hikashop_product_characteristics_table">';
			$default_item_has_stock=false;
			$variant_characteristic_id=0;
			$first_variant_characteristic_id=0;
			$first_variant_product_id=0;
			$first_ordering=0;
			$first_characteristic_id=0;
			$first_characteristic_parent_id=0;
			$first_characteristic_value=0;
			$first_characteristic_alias=0;
			foreach($obj->characteristics as $characteristic){
				$parent_characteristic_id=$characteristic->variant_characteristic_id;
				$default_characteristic_id=$characteristic->default->variant_characteristic_id;
				$main_html.='<tr>';
				$values = array();
				if(!empty($characteristic->values)){
					foreach($characteristic->values as $k => $value){
						$variant_characteristic_id=$value->variant_characteristic_id;
						$product_id=$value->variant_product_id;
						$variant_stock=$element->variants[$product_id]->product_quantity;
						if($variant_stock<>0){
							if(!$default_item_has_stock && $variant_characteristic_id==$default_characteristic_id){
									$default_item_has_stock=true;
							}
							if($first_variant_characteristic_id==0){
								$first_variant_characteristic_id=$value->variant_characteristic_id;
								$first_variant_product_id=$value->variant_product_id;
								$first_ordering=$value->ordering;
								$first_characteristic_id=$value->characteristic_id;
								$first_characteristic_parent_id=$value->characteristic_parent_id;
								$first_characteristic_value=$value->characteristic_value;
								$first_characteristic_alias=$value->characteristic_alias;
							}
							$values[$k]=$value->characteristic_value;
						}
					}
				}
			}
			if(!$default_item_has_stock){
				$obj->characteristics[$first_characteristic_parent_id]->default->variant_characteristic_id=$first_variant_characteristic_id;
				$obj->characteristics[$first_characteristic_parent_id]->default->variant_product_id=$first_variant_product_id;
				$obj->characteristics[$first_characteristic_parent_id]->default->ordering=$first_ordering;
				$obj->characteristics[$first_characteristic_parent_id]->default->characteristic_id=$first_characteristic_id;
				$obj->characteristics[$first_characteristic_parent_id]->default->characteristic_parent_id=$first_characteristic_parent_id;
				$obj->characteristics[$first_characteristic_parent_id]->default->characteristic_value=$first_characteristic_value;
				$obj->characteristics[$first_characteristic_parent_id]->default->characteristic_alias=$first_characteristic_alias;
				$default_characteristic_id=$first_variant_characteristic_id;
			}
			$html=display_characteristics($characteristic->characteristic_id,@$default_characteristic_id,$values,$params->get('characteristic_display'),$obj);
			if($params->get('characteristic_display_text')){
				$html=$characteristic->characteristic_value.'</td><td>'.$html;
			}
			$main_html.='<td>'.$html.'</td></tr>';
			$main_html.='</table>';
			if(!empty($values)){
				$js = "window.addEvent('domready', function() {var dropdown = document.getElementById('hikashop_product_characteristic_".$parent_characteristic_id."'); hikashopUpdateVariant(dropdown);});";
				$doc =& JFactory::getDocument();
				$doc->addScriptDeclaration("\n<!--\n".$js."\n//-->\n");
				$html = $main_html;
			}
		break;
	}
	return $html;
}

function display_characteristics($map,$value,$values,$characteristic_display='dropdown',$obj)
{
	if(empty($values) || !is_array($values)){
		return JText::_("Out of stock");
	}
	if(is_array($obj->characteristics)){
		$characteristic_id = $map;
		$map = 'hikashop_product_characteristic['.$characteristic_id.']';
		$id = 'hikashop_product_characteristic_'.$characteristic_id;
	}else{
		$id = $map;
	}
	$obj->values = array();
	foreach($values as $key => $val){
		if(strlen($val)!=0 && empty($val)){
			$val = $val.'&nbsp;';
		}
		$obj->values[] = JHTML::_('select.option', $key,$val);
	}
	if($characteristic_display!='radio'){
		$characteristic_display='generic';
	}
	$html = JHTML::_('select.'.$characteristic_display.'list',   $obj->values, $map, 'class="inputbox" size="1"'.$obj->options, 'value', 'text', (int)$value,$id );
	return $html;
}


